<?php

class LogLine
{
    /**
     * @var bool
     */
    public $success;
    public $type;
    public $message;
    public $timestamp;
    public $localTimestamp;
}

class Controller_Office_Sync extends Controller_Environment_Office
{
    /**
     * @return LogLine[]
     */
    private function getLog()
    {
        $config = Kohana::$config->load('sync.syncDaemon');
        $service_url = $config['url'].'/logs';
        $curl = curl_init($service_url);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        $curl_response = curl_exec($curl);
        if ($curl_response === false) {
            $info = curl_getinfo($curl);
            curl_close($curl);
            Log::instance()->add(Log::ERROR, 'error occured during curl exec. Additioanl info: ' . var_export($info));
        }
        curl_close($curl);
        /** @var LogLine[] $decoded */
        $decoded = json_decode($curl_response);
        if (isset($decoded->response->status) && $decoded->response->status == 'ERROR') {
            Log::instance()->add(Log::ERROR, 'error occured: ' . $decoded->response->errormessage);
        }

        foreach ($decoded as &$item) {
            $date = new DateTime($item->timestamp, new DateTimeZone('UTC'));
            $date->setTimezone(new DateTimeZone('MSK'));
            $item->localTimestamp = $date->format('Y-m-d H:i:s');
            $item->content = json_encode($item->content);
        }

        return $decoded;
    }

    public function action_index()
    {

        $log = $this->getLog();
        $config = Kohana::$config->load('sync.syncDaemon');
        $service_url = $config['url'];

        $this->twig->set([
            'log' => $log,
            'api_url' => $service_url,
        ])->set_filename(static::OFFICE . 'sync');
    }
}
